"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _getIterator2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/get-iterator"));

var _sort = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/sort"));

var _react = _interopRequireWildcard(require("react"));

var _ImageGrid = _interopRequireDefault(require("./ImageGrid"));

var _helpers = require("../utils/helpers");

// @flow

/**
 * Displays a grid of all photos attached to observations.
 */
var MediaViewContent = function MediaViewContent(_ref) {
  var observations = _ref.observations,
      onClick = _ref.onClick,
      getMedia = _ref.getMedia;
  var images = (0, _react.useMemo)(function () {
    var images = [];
    var sortedObservations = (0, _sort["default"])(observations).call(observations, function (a, b) {
      return a.created_at > b.created_at ? -1 : a.created_at < b.created_at ? 1 : 0;
    });
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator2["default"])(sortedObservations), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var obs = _step.value;
        var attachments = obs.attachments || [];

        for (var i = 0; i < attachments.length; i++) {
          // Only return attachments with images
          if (!(0, _helpers.isImageAttachment)(attachments[i])) continue; // check we can actually get an image src for each one before adding it

          var media = getMedia(attachments[i], {
            width: 200,
            height: 200
          });
          if (media) images.push({
            index: i,
            src: media.src,
            observationId: obs.id
          });
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator["return"] != null) {
          _iterator["return"]();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return images;
  }, [observations, getMedia]);
  return _react["default"].createElement(_ImageGrid["default"], {
    images: images,
    onImageClick: onClick
  });
};

var _default = MediaViewContent;
exports["default"] = _default;
//# sourceMappingURL=MediaViewContent.js.map