"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _Chip = _interopRequireDefault(require("@material-ui/core/Chip"));

var _Select = _interopRequireDefault(require("./Select"));

var styleSheet = {
  row: {
    display: 'flex',
    flexWrap: 'wrap',
    marginTop: -3
  },
  chip: {
    margin: '3px 3px 0 0',
    height: 30
  },
  select: {
    minWidth: 220
  },
  highlight: {
    backgroundColor: '#ff9696'
  }
};

var MultiSelect =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(MultiSelect, _Component);

  function MultiSelect() {
    var _getPrototypeOf2, _context, _context2;

    var _this;

    (0, _classCallCheck2["default"])(this, MultiSelect);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(MultiSelect)).call.apply(_getPrototypeOf2, (0, _concat["default"])(_context = [this]).call(_context, args)));
    _this.state = {
      selectValue: '',
      suggestions: (0, _filter["default"])(_context2 = _this.props.suggestions).call(_context2, function (s) {
        var _context3;

        return (0, _indexOf["default"])(_context3 = _this.props.value).call(_context3, s) === -1;
      })
    };

    _this.handleSelectChange = function (e, d) {
      _this.setState({
        selectValue: d.newValue
      });
    };

    _this.handleKeyDown = function (e) {
      var _context4;

      if (_this.justAdded || e.keyCode !== 13) {
        _this.justAdded = false;
        return;
      }

      var newValue = _this.state.selectValue;
      var index = (0, _indexOf["default"])(_context4 = _this.props.value).call(_context4, newValue);

      if (index > -1) {
        _this.highlightChip(index);

        _this.setState({
          selectValue: ''
        });
      } else {
        _this.handleSuggestionSelected(e, {
          suggestionValue: newValue
        });
      }
    };

    _this.handleSuggestionSelected = function (e, d) {
      var _context5;

      var newValue = (0, _concat["default"])(_context5 = _this.props.value).call(_context5, d.suggestionValue);
      _this.justAdded = true;

      _this.setState({
        selectValue: ''
      });

      _this.props.onChange(e, {
        newValue: newValue,
        type: 'add'
      });
    };

    _this.handleRequestDelete = function (i) {
      return function (e) {
        var _context6;

        var value = _this.props.value;
        var newValue = (0, _concat["default"])(_context6 = (0, _slice["default"])(value).call(value, 0, i)).call(_context6, (0, _slice["default"])(value).call(value, i + 1));

        _this.props.onChange(e, {
          newValue: newValue,
          type: 'delete'
        });
      };
    };

    return _this;
  }

  (0, _createClass2["default"])(MultiSelect, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        var _context7;

        var suggestions = (0, _filter["default"])(_context7 = nextProps.suggestions).call(_context7, function (s) {
          var _context8;

          return (0, _indexOf["default"])(_context8 = nextProps.value).call(_context8, s) === -1;
        });
        this.setState({
          suggestions: suggestions
        });
      }
    }
  }, {
    key: "highlightChip",
    value: function highlightChip(i) {
      var _this2 = this;

      this.setState({
        highlight: i
      });
      (0, _setTimeout2["default"])(function () {
        return _this2.setState({
          highlight: null
        });
      }, 500);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          value = _this$props.value;
      return _react["default"].createElement("div", {
        className: classes.row
      }, (0, _map["default"])(value).call(value, function (d, i) {
        return _react["default"].createElement(_Chip["default"], {
          label: d,
          key: i,
          onRequestDelete: _this3.handleRequestDelete(i),
          className: classes.chip + (_this3.state.highlight === i ? ' ' + classes.highlight : '')
        });
      }), _react["default"].createElement(_Select["default"], {
        value: this.state.selectValue,
        suggestions: this.state.suggestions,
        onChange: this.handleSelectChange,
        onKeyDown: this.handleKeyDown,
        onSuggestionSelected: this.handleSuggestionSelected,
        className: classes.select
      }));
    }
  }]);
  return MultiSelect;
}(_react.Component);

MultiSelect.propTypes = {
  classes: _propTypes["default"].object.isRequired,
  className: _propTypes["default"].string,
  value: _propTypes["default"].array
};
MultiSelect.defaultProps = {
  value: []
};

var _default = (0, _styles.withStyles)(styleSheet)(MultiSelect);

exports["default"] = _default;
//# sourceMappingURL=MultiSelect.js.map